Crystal::Macros::StringLiteral - Crystal 1.16.3

# class Crystal::Macros::StringLiteral

- Crystal::Macros::StringLiteral
- Crystal::Macros::ASTNode

##
Overview

A string literal.

##
Defined in:

compiler/crystal/macros.cr

##
Instance Method Summary

- #+(other : StringLiteral | CharLiteral) : StringLiteral

  Similar to `String#+`.

- #<(other : StringLiteral | MacroId) : BoolLiteral

  Similar to `String#<`

- #=~(range : RegexLiteral) : BoolLiteral

  Similar to `String#=~`.

- #>(other : StringLiteral | MacroId) : BoolLiteral

  Similar to `String#>`

- #[](range : RangeLiteral) : StringLiteral

  Similar to `String#[]`.

- #camelcase(*, lower : BoolLiteral = false) : StringLiteral

  Similar to `String#camelcase`.

- #capitalize : StringLiteral

  Similar to `String#capitalize`.

- #chars : ArrayLiteral(CharLiteral)

  Similar to `String#chars`.

- #chomp : StringLiteral

  Similar to `String#chomp`.

- #count(other : CharLiteral) : NumberLiteral

  Similar to `String#count`.

- #downcase : StringLiteral

  Similar to `String#downcase`.

- #empty? : BoolLiteral

  Similar to `String#empty?`.

- #ends_with?(other : StringLiteral | CharLiteral) : BoolLiteral

  Similar to `String#ends_with?`.

- #gsub(regex : RegexLiteral, replacement : StringLiteral) : StringLiteral

  Similar to `String#gsub`.

- #id : MacroId

  Returns a `MacroId` for this string's contents.

- #includes?(search : StringLiteral | CharLiteral) : BoolLiteral

  Similar to `String#includes?`.

- #lines : ArrayLiteral(StringLiteral)

  Similar to `String#lines`.

- #scan(regex : RegexLiteral) : ArrayLiteral(HashLiteral(NumberLiteral | StringLiteral), StringLiteral | NilLiteral)

  Returns an array of capture hashes for each match of regex in this string.

- #size : NumberLiteral

  Similar to `String#size`.

- #split(node : ASTNode) : ArrayLiteral(StringLiteral)

  Similar to `String#split`.

- #split : ArrayLiteral(StringLiteral)

  Similar to `String#split`.

- #starts_with?(other : StringLiteral | CharLiteral) : BoolLiteral

  Similar to `String#starts_with?`.

- #strip : StringLiteral

  Similar to `String#strip`.

- #titleize : StringLiteral

  Similar to `String#titleize`.

- #to_i(base = 10)

  Similar to `String#to_i`.

- #tr(from : StringLiteral, to : StringLiteral) : StringLiteral

  Similar to `String#tr`.

- #underscore : StringLiteral

  Similar to `String#underscore`.

- #upcase : StringLiteral

  Similar to `String#upcase`.

### Instance methods inherited from class `Crystal::Macros::ASTNode`

!=(other : ASTNode) : BoolLiteral !=, ==(other : ASTNode) : BoolLiteral ==, class_name : StringLiteral class_name, column_number : StringLiteral | NilLiteral column_number, doc : StringLiteral doc, doc_comment : MacroId doc_comment, end_column_number : StringLiteral | NilLiteral end_column_number, end_line_number : StringLiteral | NilLiteral end_line_number, filename : StringLiteral | NilLiteral filename, id : MacroId id, is_a?(type : TypeNode) : BoolLiteral is_a?, line_number : StringLiteral | NilLiteral line_number, nil? : BoolLiteral nil?, raise(message) : NoReturn raise, stringify : StringLiteral stringify, symbolize : SymbolLiteral symbolize, warning(message : StringLiteral) : NilLiteral warning

##
Instance Method Detail

def +(other : StringLiteral | CharLiteral) : StringLiteral #

Similar to `String#+`.

def <(other : StringLiteral | MacroId) : BoolLiteral #

Similar to `String#<`

def =~(range : RegexLiteral) : BoolLiteral #

Similar to `String#=~`.

def >(other : StringLiteral | MacroId) : BoolLiteral #

Similar to `String#>`

def [](range : RangeLiteral) : StringLiteral #

Similar to `String#[]`.

def camelcase(*, lower : BoolLiteral = false) : StringLiteral #

Similar to `String#camelcase`.

def capitalize : StringLiteral #

Similar to `String#capitalize`.

def chars : ArrayLiteral(CharLiteral) #

Similar to `String#chars`.

def chomp : StringLiteral #

Similar to `String#chomp`.

def count(other : CharLiteral) : NumberLiteral #

Similar to `String#count`.

def downcase : StringLiteral #

Similar to `String#downcase`.

def empty? : BoolLiteral #

Similar to `String#empty?`.

def ends_with?(other : StringLiteral | CharLiteral) : BoolLiteral #

Similar to `String#ends_with?`.

def gsub(regex : RegexLiteral, replacement : StringLiteral) : StringLiteral #

Similar to `String#gsub`.

def id : MacroId #

Returns a `MacroId` for this string's contents.

def includes?(search : StringLiteral | CharLiteral) : BoolLiteral #

Similar to `String#includes?`.

def lines : ArrayLiteral(StringLiteral) #

Similar to `String#lines`.

def scan(regex : RegexLiteral) : ArrayLiteral(HashLiteral(NumberLiteral | StringLiteral), StringLiteral | NilLiteral) #

Returns an array of capture hashes for each match of regex in this string.

Capture hashes have the same form as `Regex::MatchData#to_h`.

def size : NumberLiteral #

Similar to `String#size`.

def split(node : ASTNode) : ArrayLiteral(StringLiteral) #

Similar to `String#split`.

def split : ArrayLiteral(StringLiteral) #

Similar to `String#split`.

def starts_with?(other : StringLiteral | CharLiteral) : BoolLiteral #

Similar to `String#starts_with?`.

def strip : StringLiteral #

Similar to `String#strip`.

def titleize : StringLiteral #

Similar to `String#titleize`.

def to_i(base = 10) #

Similar to `String#to_i`.

def tr(from : StringLiteral, to : StringLiteral) : StringLiteral #

Similar to `String#tr`.

def underscore : StringLiteral #

Similar to `String#underscore`.

def upcase : StringLiteral #

Similar to `String#upcase`.